<template>
  <div class="app-container">
    <el-button
      v-if="['add', 'edit'].includes($attrs.optType)"
      type="primary"
      plain
      icon="el-icon-plus"
      size="mini"
      @click="$refs['ItemSelectRef'].showFlag = true"
    >新增</el-button>
    <ItemSelect ref="ItemSelectRef" @onSelected="onItemSelect" />
    <el-table v-loading="loading" :data="tmToolRequestItemList" @selection-change="handleSelectionChange">
      <!-- <el-table-column type="selection" width="55" align="center" /> -->
      <!-- <el-table-column label="主键id" align="center" prop="toolRequestItemId" /> -->
      <el-table-column label="序号" align="center" type="index" />
      <el-table-column label="刀模版物料名称" align="center" prop="itemName" />
      <el-table-column  width="120px" label="预计使用寿命" align="center" prop="estimatedLifeTime" />
      <el-table-column  width="120px" label="是否校验" align="center" prop="inspectionStatus">
        <template slot-scope="scope">
          {{ scope.row.inspectionStatus ? "是" : "否" }}
          </template>
      </el-table-column>
      <el-table-column width="120px" v-if="['add', 'edit'].includes($attrs.optType)" label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            v-if="['edit'].includes($attrs.optType) && scope.row.addMachinesStatus"
            size="mini"
            type="text"
            @click="handleCheck(scope.row, scope.$index)"
          >跳过校验</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleRemove(scope.row, scope.$index)"
          >删除</el-button>
          </template>
        </el-table-column>
    </el-table>
    <pagination
      v-if="total > 0 && ['add'].includes($attrs.optType)"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getTaskList"
    />
    <!-- 添加或修改刀模版物料申请单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="刀模版申请单id" prop="toolRequestId">
          <el-input v-model="form.toolRequestId" placeholder="请输入刀模版申请单id" />
        </el-form-item>
        <el-form-item label="物料id" prop="itemId">
          <el-input v-model="form.itemId" placeholder="请输入物料id" />
        </el-form-item>
        <el-form-item label="数量" prop="allQuantity">
          <el-input v-model="form.allQuantity" placeholder="请输入总数量" />
        </el-form-item>
        <el-form-item label="预计使用寿命" prop="nextMaintenPeriod">
          <el-input v-model="form.nextMaintenPeriod" placeholder="请输入预计使用寿命" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <el-dialog title="确认物料数量" :visible.sync="quantity.open" width="800px" append-to-body>
      <el-table :data="quantity.list">
        <el-table-column label="物料编码" align="center" prop="itemCode" />
        <el-table-column label="物料名称" align="center" prop="itemName" />
        <el-table-column label="物料数量" align="center" prop="allQuantity" >
          <template slot-scope="scope">
            <el-input-number v-model="scope.row.num" placeholder="请输入物料数量" :min="1"/>
          </template>
        </el-table-column>
      </el-table>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitQuantity">确 定</el-button>
        <el-button @click="quantity.open=false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listTmToolRequestItem, getTmToolRequestItem, delTmToolRequestItem, addTmToolRequestItem, updateTmToolRequestItem } from "@/api/mes/tm/tmToolRequestItem";
import { getTaskIdMaxProcessTool, updateNotInspectionStatusApi } from "@/api/mes/pro/protask";
import ItemSelect from "@/components/itemSelect/index.vue";
export default {
  name: "TmToolRequestItem",
  components: {ItemSelect},
  props:{
    toolRequestId:{
      type: Number,
      default: 0
    }
  },
  data() {
    return {
      // 遮罩层
      loading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 刀模版物料申请单表格数据
      tmToolRequestItemList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        toolRequestId: null,
        temId: null,
        allQuantity: null,
        nextMaintenPeriod: null,
        },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      quantity: {
        value: 1,
        open: false,
        list: []
      },
      addList: [],
      detailList: []
    };
  },
  watch: {
     '$attrs.taskId'(newVal, oldVal){
      if(['add', 'edit'].includes(this.$attrs.optType)) {
        this.getTaskList()
      }
     }
  },
  created() {
    if(!['add'].includes(this.$attrs.optType)) {
      this.getList();
    }
  },
  methods: {
    onItemSelect(list){
      // console.log(list, 'list')
      const listpa = JSON.parse(JSON.stringify(list))
      listpa.map(v => v.num = 1)
      this.quantity = {
        open: true,
        value: 1,
        list: list
      }
    },
    submitQuantity(){
      this.addList = []
      this.quantity.list.forEach(item => {
        for(let i = 0; i < item.num; i++){
          this.addList.push({
            itemId:item.itemId,
            itemName:item.itemName,
            estimatedLifeTime: Number(this.$attrs.quantity) || 0
          })
        }
      })
      this.tmToolRequestItemList = this.tmToolRequestItemList.concat(JSON.parse(JSON.stringify(this.addList)))
      this.quantity.open = false
      this.$emit('sum')
    },
    /** 查询刀模版物料申请单列表 */
    getList() {
      this.loading = true;
      this.queryParams.toolRequestId = this.toolRequestId;
      listTmToolRequestItem(this.queryParams).then(response => {
        this.tmToolRequestItemList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询任务刀模版申请单列表 */
    getTaskList() {
      this.loading = true;
      this.queryParams.taskId = this.$attrs.taskId;
      this.queryParams.pageSize = 10000;
      getTaskIdMaxProcessTool(this.queryParams).then(response => {
        this.detailList = response.data.map(item => {
           return {
             ...item,
             allQuantity: Number(item.AllQuantity)
           }
        });
        this.addList = this.addList.map(item => {
          return {
            ...item,
            nextMaintenPeriod: Number(this.$attrs.quantity)
          }
        })
        this.tmToolRequestItemList = this.detailList.concat(this.addList)
        // this.total = response.total;
        this.loading = false;
        this.$emit('sum')
      });
    },
    async handleCheck(row, index) {
      const params = {
        toolRequestItemId: row.toolRequestItemId,
        inspectionStatus: !row.inspectionStatus
      };
      const res = await updateNotInspectionStatusApi(params);
      if(res.code == 200) {
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }
    },
    handleRemove(row, index) {
      console.log(row,index)
      this.tmToolRequestItemList.splice(index, 1)
      this.$emit('sum')
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        toolRequestItemId: null,
        toolRequestId: null,
        itemId: null,
        allQuantity: null,
        nextMaintenPeriod: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.toolRequestItemId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加刀模版物料申请单";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const toolRequestItemId = row.toolRequestItemId || this.ids
      getTmToolRequestItem(toolRequestItemId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改刀模版物料申请单";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.toolRequestItemId != null) {
            updateTmToolRequestItem(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTmToolRequestItem(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const toolRequestItemIds = row.toolRequestItemId || this.ids;
      this.$modal.confirm('是否确认删除刀模版物料申请单编号为"' + toolRequestItemIds + '"的数据项？').then(function() {
        return delTmToolRequestItem(toolRequestItemIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('tm/tmToolRequestItem/export', {
        ...this.queryParams
      }, `tmToolRequestItem_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
